## octave-nan 1.0.6

=== DESCRIPTION ===
Name: NaN
Version: 1.0.6
Date: 2008-04-29
Author: Alois Schloegl <a.schloegl@ieee.org>
Maintainer: Matthew W. Roberts
Title: NaN statisical toolbox
Description: Missing value statistical toolbox
Depends: octave (>= 2.9.7)
License: GPL version 2 or later
Url: http://www.dpmi.tu-graz.ac.at/~schloegl/matlab/NaN

## octave-nan 1.0.8

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Name: NaN
-Version: 1.0.6
-Date: 2008-04-29
+Version: 1.0.8
+Date: 2009-05-03
 Author: Alois Schloegl <a.schloegl@ieee.org>
 Maintainer: Matthew W. Roberts
 Title: NaN statisical toolbox

## octave-nan 1.0.9

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Name: NaN
-Version: 1.0.8
+Version: 1.0.9
 Date: 2009-05-03
 Author: Alois Schloegl <a.schloegl@ieee.org>
 Maintainer: Matthew W. Roberts

=== src/Makefile ===
PROGS = $(patsubst %.cpp,%.mex,$(wildcard *.cpp))

all: $(PROGS)

$(PROGS): Makefile

%.oct: %.cc
	mkoctfile $<

%.mex: %.cpp
	mkoctfile --mex $<

clean: ; -$(RM) *.o core octave-core *.oct *~ *.mex

=== debian/changelog ===
octave-nan (1.0.9-2) unstable; urgency=low

  * debian/control: 
    - Remove Rafael Laboissiere from Uploaders (Closes: #571853)
    - Remove Ólafur Jens Sigurðsson <ojsbug@gmail.com> from Uploaders 
  * New patch: fix_empty_opt_argument_for_var: correctly handle the case of an
    empty second argument for var() (closes: #594906).
  * Switch to dpkg-source 3.0 (quilt) format

 -- Thomas Weber <tweber@debian.org>  Wed, 01 Sep 2010 22:52:55 +0200

octave-nan (1.0.9-1) unstable; urgency=low

  [ Rafael Laboissiere ]
  * debian/patches/autoload-yes.diff: Drop this patch.  This package
    should not be autoloaded since it overrides the standard functions
    provided in octave3.0.
  * debian/control, debian/rules: Adjust to not use quilt anymore
  * debian/README.source: Removed file
  * debian/NEWS: Add a note explaining the change above
  * debian/control: Build-depend on octave-pkg-dev >= 0.7.0, such that the
    package is built against octave3.2

  [ Thomas Weber ]
  * New upstream release.
  * Use debian/octave-nan.docs for installation, following the change to
    octave-pkg-dev 0.7.1. Adjust debian/rules for this change.

 -- Thomas Weber <thomas.weber.mail@gmail.com>  Tue, 29 Dec 2009 23:45:06 +0100

octave-nan (1.0.8-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + (Standards-Version): Bump to 3.8.1 (add file debian/README.source)
    + (Depends): Add ${misc:Depends}
    + (Vcs-Git, Vcs-Browser): Adjust to new Git repository
  * debian/copyright: Use DEP5 URL in Format-Specification
  * debian/patches/autoload-yes.diff: Add description

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 24 May 2009 15:19:15 +0200

octave-nan (1.0.7-2) unstable; urgency=low

  [ Rafael Laboissiere ]
  * debian/copyright: Add header
  * debian/control: Bump build-dependency on octave-pkg-dev to >= 0.6.4,
    such that the package is built with the versioned packages directory

  [ Thomas Weber ]
  * Upload to unstable (closes: #501016)

 -- Thomas Weber <thomas.weber.mail@gmail.com>  Sun, 05 Apr 2009 21:20:57 +0200

octave-nan (1.0.7-1) experimental; urgency=low

  [ Ólafur Jens Sigurðsson ]
  * debian/control: Bumped Standards-Version to 3.8.0 (no changes
    needed)

  [ Thomas Weber ]
  * New upstream release, handles empty second argument to std() correctly
    (closes: #500252)
  * Bump dependency on octave-pkg-dev to 0.6.1, to get the experimental
    version

 -- Thomas Weber <thomas.weber.mail@gmail.com>  Thu, 11 Dec 2008 00:32:40 +0100

octave-nan (1.0.6-1) unstable; urgency=low

  * Initial release (closes: #481484)

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 16 May 2008 14:09:37 +0000

=== debian/control ===
Source: octave-nan
Section: math
Priority: optional
Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
Uploaders: Thomas Weber <thomas.weber.mail@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 6), cdbs, octave-pkg-dev (>= 0.7.0)
Standards-Version: 3.8.1
Homepage: http://octave.sourceforge.net/nan/
Vcs-Git: git://git.debian.org/git/pkg-octave/octave-nan.git
Vcs-Browser: http://git.debian.org/?p=pkg-octave/octave-nan.git

Package: octave-nan
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${octave:Depends}
Description: handles data with and without missing values in Octave
 This package allows the handling of data with and without missing
 values by using NaN in Octave. Features of this package includes:
 implement of the statistical tools, supports DIM argument, supports
 unbiased estimation significance test, confidence intervals and
 Spearman`s rank correlation included in CORRCOEF.
 .
 Be warned that this package changes the way NaNs are handled in Octave!
 .
 This Octave add-on package is part of the Octave-Forge project.

=== debian/watch ===
version=3
http://octave.sourceforge.net/packages.php \
    http://downloads\.sourceforge\.net/octave/nan-([\d.]+)\.tar\.gz\?download

## octave-nan 2.3.1

=== DESCRIPTION ===
Name: NaN
Version: 2.3.1
Date: 2010-09-08
Author: Alois Schloegl <a.schloegl@ieee.org>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for Octave and Matlab for data with and w/o missing values.
Depends: octave (> 2.9.0)
License: GPL version 3 or later
Url: http://biosig-consulting.com/matlab/NaN

=== src/Makefile ===

CC  	= gcc
CXX 	= g++
CFLAGS 	= -Wall -Wconversion -O3 -fPIC
OCTMEX	= mkoctfile --mex

MATLABDIR = /usr/local/matlab
MEX_OPTION = CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
# comment the following line if you use MATLAB on 32-bit computer
MEX_OPTION += -largeArrayDims
MATMEX	= $(MATLABDIR)/bin/mex $(MEX_OPTION)



PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex

octave: $(PROGS)

MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)
matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
all: $(PROGS) $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))

$(PROGS): Makefile

%.oct: %.cc
	mkoctfile $<

%.mex: %.cpp
	$(OCTMEX) $<           ## Octave
%.$(MEX_EXT): %.cpp
	$(MATMEX) $<           ## Matlab

svmtrain_mex.mex svmpredict_mex.mex:     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
	$(CXX) $(CFLAGS) -I /usr/include/octave -c svm.cpp
	$(CC) $(CFLAGS) -I /usr/include/octave -c svm_model_matlab.c
	env CC=$(CXX) $(OCTMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
	env CC=$(CXX) $(OCTMEX) svmpredict_mex.cpp svm.o svm_model_matlab.o

svmtrain_mex.$(MEX_EXT) svmpredict_mex.$(MEX_EXT):     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
	$(CXX) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm.cpp
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm_model_matlab.c
	$(MATMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
	$(MATMEX) svmpredict_mex.cpp svm.o svm_model_matlab.o

train.$(MEX_EXT) predict.$(MEX_EXT): train.c linear.h tron.o linear.o linear_model_matlab.c
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c linear_model_matlab.c
	$(MATMEX)  -lblas train.c tron.o linear.o linear_model_matlab.o 
	#$(MATMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o

train.mex predict.mex: train.c linear.h tron.o linear.o linear_model_matlab.c
	$(CC) $(CFLAGS) -I /usr/include/octave -c linear_model_matlab.c
	env CC=$(CXX) $(OCTMEX) -lblas train.c tron.o linear.o linear_model_matlab.o
	#env CC=$(CXX) $(OCTMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c linear.cpp

tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c tron.cpp



clean: ; -$(RM) *.o core octave-core *.oct *~ *.mex*

=== debian/changelog ===
octave-nan (2.3.1-2) experimental; urgency=low

  * Run test suite via debian/check.m
  * New patch: fprintf_does_not_like_cells, fixes a problem with fprintf in
    the test suite

 -- Thomas Weber <tweber@debian.org>  Sat, 02 Oct 2010 23:48:41 +0200

octave-nan (2.3.1-1) experimental; urgency=low

  * New upstream version (closes: 595811)
  * Adapt watch file for individual package releases
  * Dropped patches: fix_empty_opt_argument_for_var (applied upstream)

 -- Thomas Weber <tweber@debian.org>  Sun, 26 Sep 2010 19:31:17 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: math
 Priority: optional
 Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
-Uploaders: Thomas Weber <thomas.weber.mail@gmail.com>
+Uploaders: Thomas Weber <tweber@debian.org>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 6), cdbs, octave-pkg-dev (>= 0.7.0)
 Standards-Version: 3.8.1

## octave-nan 2.4.1

=== DESCRIPTION ===
Name: NaN
Version: 2.4.1
Date: 2011-04-20
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for Octave and Matlab for data with and w/o missing values.
Depends: octave (> 2.9.0)
License: GPL version 3 or later
Url: http://pub.ist.ac.at/~schloegl/matlab/NaN

=== src/Makefile ===
####################################################
# Copyright 2010, 2011 Alois Schloegl 
# This is part of the NaN-toolbox - a statistics and machine learning toolbox for data with and without missing values. 
# http://pub.ist.ac.at/~schloegl/matlab/NaN/
####################################################

### modify directories according to your needs 

# Octave - global install  (e.g. from debian package)
OCTAVE_VERSION = 
INCOCTAVE = -I /usr/include/octave 
# Octave - local install (e.g. compiled from sources) 
OCTAVE_VERSION = -3.4.0
INCOCTAVE = -I /usr/local/include/octave$(OCTAVE_VERSION)/octave 

# Matlab configuration
MATLABDIR = /usr/local/MATLAB/R2010b
# comment the following line if you use MATLAB on 32-bit operating system
MEX_OPTION += -largeArrayDims

# Mingw crosscompiler: available at http://www.nongnu.org/mingw-cross-env/
CROSS   = $(HOME)/src/mingw-cross-env/usr/bin/i686-pc-mingw32-
# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/Matlab/R2010/extern/include/
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX  = $(HOME)/bin/gnumex
####################################################

CC  	= gcc
CXX 	= g++
CFLAGS 	= -fopenmp -Wall -Wconversion -O2 -fPIC 
OCTMEX	= mkoctfile$(OCTAVE_VERSION) --mex
RM      = rm

MEX_OPTION  += -lz -lgomp CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
MATMEX      = $(MATLABDIR)/bin/mex $(MEX_OPTION)

PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex 

MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)
octave: $(PROGS)
matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
mexw32 win32:  $(patsubst %.mex, %.mexw32, $(PROGS))
all:    octave matlab win32

$(PROGS): Makefile

#########################################################
#	Octave, MATLAB on Linux 
#########################################################
%.oct: %.cc
	mkoctfile$(OCTAVE_VERSION) $<

%.mex: %.cpp
	$(OCTMEX) $<  -lz -lgomp         ## Octave
%.$(MEX_EXT): %.cpp
	$(MATMEX) $<  -lz -lgomp      ## Matlab

svmtrain_mex.mex svmpredict_mex.mex:     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
	$(CXX) $(CFLAGS) $(INCOCTAVE) -c svm.cpp
	$(CC)  $(CFLAGS) $(INCOCTAVE) -c svm_model_matlab.c
	env CC=$(CXX) $(OCTMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
	env CC=$(CXX) $(OCTMEX) svmpredict_mex.cpp svm.o svm_model_matlab.o

svmtrain_mex.$(MEX_EXT) svmpredict_mex.$(MEX_EXT):     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
	$(CXX) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm.cpp
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm_model_matlab.c
	$(MATMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
	$(MATMEX) svmpredict_mex.cpp svm.o svm_model_matlab.o

train.$(MEX_EXT) predict.$(MEX_EXT): train.c linear.h tron.o linear.o linear_model_matlab.c
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c linear_model_matlab.c
	$(MATMEX)  -lblas train.c tron.o linear.o linear_model_matlab.o 
	#$(MATMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o

train.mex predict.mex: train.c linear.h tron.o linear.o linear_model_matlab.c
	$(CC) $(CFLAGS) $(INCOCTAVE) -c linear_model_matlab.c
	env CC=$(CXX) $(OCTMEX) -lblas train.c tron.o linear.o linear_model_matlab.o
	#env CC=$(CXX) $(OCTMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o

linear.o: linear.cpp linear.h
	$(CXX) $(CFLAGS) -c linear.cpp

tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c tron.cpp


clean: ; -$(RM) *.o core octave-core *.oct *~ *.mex*

#########################################################
#	MATLAB/WIN32
#########################################################
%.obj: %.cpp
	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $<
%.obj: %.c
	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 
#%.obj: LAPACK/%.f
#	$(CROSS)$(CXX) -c -DMATLAB_MEX_FILE -o$@ -I$(W32MAT_INC) -O3 -DMX_COMPAT_32 $< 

train.mexw32 predict.mexw32:  train.obj linear.obj linear_model_matlab.obj tron.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< linear_model_matlab.obj linear.obj tron.obj -llibmx -llibmex -llibmat -lz -lcholmod -lblas

svmpredict_mex.mexw32 :  svmpredict_mex.obj svm.obj svm_model_matlab.obj 
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lz -lcholmod
svmtrain_mex.mexw32 : svmtrain_mex.obj svm.obj svm_model_matlab.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lz -lcholmod

%.mexw32: %.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex -llibmat -lz -lcholmod -lgomp -lpthread

clean:
	-$(RM) *.o *.obj core octave-core *.oct *~ *.mex*

=== debian/changelog ===
octave-nan (2.4.1-2) unstable; urgency=low

  * Add patch fix_makefile, for adapting the values to Octave 3.2

 -- Thomas Weber <tweber@debian.org>  Sun, 15 May 2011 13:19:17 +0200

octave-nan (2.4.1-1) unstable; urgency=low

  * New upstream release
  * Bump standards version to 3.9.1, no changes required

 -- Thomas Weber <tweber@debian.org>  Tue, 26 Apr 2011 11:30:23 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Thomas Weber <tweber@debian.org>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 6), cdbs, octave-pkg-dev (>= 0.7.0)
-Standards-Version: 3.8.1
+Standards-Version: 3.9.1
 Homepage: http://octave.sourceforge.net/nan/
 Vcs-Git: git://git.debian.org/git/pkg-octave/octave-nan.git
 Vcs-Browser: http://git.debian.org/?p=pkg-octave/octave-nan.git

=== debian/watch ===
version=3
http://octave.sourceforge.net/packages.php \
    http://sourceforge.net/projects/octave/files/Octave%20Forge%20Packages/Individual%20Package%20Releases/nan-([\d.]+)\.tar\.gz/download

## octave-nan 2.4.4

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Name: NaN
-Version: 2.4.1
-Date: 2011-04-20
+Version: 2.4.4
+Date: 2011-05-27
 Author: Alois Schloegl <alois.schloegl@gmail.com>
 Maintainer: Alois Schloegl
 Title: The NaN-toolbox

=== src/Makefile ===
--- 
+++ 
@@ -7,11 +7,7 @@
 ### modify directories according to your needs 
 
 # Octave - global install  (e.g. from debian package)
-OCTAVE_VERSION = 
-INCOCTAVE = -I /usr/include/octave 
-# Octave - local install (e.g. compiled from sources) 
-OCTAVE_VERSION = -3.4.0
-INCOCTAVE = -I /usr/local/include/octave$(OCTAVE_VERSION)/octave 
+# OCTAVE_VERSION = 
 
 # Matlab configuration
 MATLABDIR = /usr/local/MATLAB/R2010b
@@ -20,10 +16,16 @@
 
 # Mingw crosscompiler: available at http://www.nongnu.org/mingw-cross-env/
 CROSS   = $(HOME)/src/mingw-cross-env/usr/bin/i686-pc-mingw32-
+CROSS64 = $(HOME)/src/mce-w64/usr/bin/x86_64-w64-mingw32-
 # include directory for Win32-Matlab include
-W32MAT_INC = $(HOME)/bin/Matlab/R2010/extern/include/
+W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/
+W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/
 # path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
-GNUMEX  = $(HOME)/bin/gnumex
+GNUMEX   = $(HOME)/bin/win32/gnumex
+GNUMEX64 = $(HOME)/bin/win64/gnumex
+# building gnumex64 was difficult, these hints were quite useful: 
+# http://sourceforge.net/mailarchive/forum.php?thread_name=AANLkTinZvxgC9ezp2P3UCX_a7TAUYuVsp2U40MQUV6qr%40mail.gmail.com&forum_name=gnumex-users
+# Instead of building "mex shortpath.c" and "mex uigetpath.c", I used empty m-functions within argout=argin; 
 ####################################################
 
 CC  	= gcc
@@ -37,13 +39,18 @@
 
 PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex 
 
+mex4o octave: $(PROGS)
+
+ifneq ( , $(ls -1 $(MATLABDIR) ) )
 MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)
-octave: $(PROGS)
-matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
+mex4m matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
+endif
 mexw32 win32:  $(patsubst %.mex, %.mexw32, $(PROGS))
-all:    octave matlab win32
+mexw64 win64:  $(patsubst %.mex, %.mexw64, $(PROGS))
+all:    octave win32 win64 mex4m
 
-$(PROGS): Makefile
+clean:
+	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 
 
 #########################################################
 #	Octave, MATLAB on Linux 
@@ -57,10 +64,10 @@
 	$(MATMEX) $<  -lz -lgomp      ## Matlab
 
 svmtrain_mex.mex svmpredict_mex.mex:     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
-	$(CXX) $(CFLAGS) $(INCOCTAVE) -c svm.cpp
-	$(CC)  $(CFLAGS) $(INCOCTAVE) -c svm_model_matlab.c
-	env CC=$(CXX) $(OCTMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
-	env CC=$(CXX) $(OCTMEX) svmpredict_mex.cpp svm.o svm_model_matlab.o
+	$(CXX) $(CFLAGS) -c svm.cpp
+	#$(CC)  $(CFLAGS) $(INCOCTAVE) -c svm_model_matlab.c
+	env CC=$(CXX) $(OCTMEX) svmtrain_mex.cpp svm.o svm_model_matlab.c
+	env CC=$(CXX) $(OCTMEX) svmpredict_mex.cpp svm.o svm_model_matlab.c
 
 svmtrain_mex.$(MEX_EXT) svmpredict_mex.$(MEX_EXT):     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
 	$(CXX) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm.cpp
@@ -74,8 +81,7 @@
 	#$(MATMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o
 
 train.mex predict.mex: train.c linear.h tron.o linear.o linear_model_matlab.c
-	$(CC) $(CFLAGS) $(INCOCTAVE) -c linear_model_matlab.c
-	env CC=$(CXX) $(OCTMEX) -lblas train.c tron.o linear.o linear_model_matlab.o
+	env CC=$(CXX) $(OCTMEX) -lblas train.c tron.o linear.o linear_model_matlab.c
 	#env CC=$(CXX) $(OCTMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o
 
 linear.o: linear.cpp linear.h
@@ -85,8 +91,6 @@
 	$(CXX) $(CFLAGS) -c tron.cpp
 
 
-clean: ; -$(RM) *.o core octave-core *.oct *~ *.mex*
-
 #########################################################
 #	MATLAB/WIN32
 #########################################################
@@ -94,8 +98,6 @@
 	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $<
 %.obj: %.c
 	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 
-#%.obj: LAPACK/%.f
-#	$(CROSS)$(CXX) -c -DMATLAB_MEX_FILE -o$@ -I$(W32MAT_INC) -O3 -DMX_COMPAT_32 $< 
 
 train.mexw32 predict.mexw32:  train.obj linear.obj linear_model_matlab.obj tron.obj
 	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< linear_model_matlab.obj linear.obj tron.obj -llibmx -llibmex -llibmat -lz -lcholmod -lblas
@@ -108,8 +110,26 @@
 %.mexw32: %.obj
 	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex -llibmat -lz -lcholmod -lgomp -lpthread
 
-clean:
-	-$(RM) *.o *.obj core octave-core *.oct *~ *.mex*
 
 
+#########################################################
+#	MATLAB/WIN64
+#########################################################
 
+## ToDO: fix OpenMP support: currently -fopenmp causes Matlab to crash
+%.o64: %.cpp
+	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O2 $<
+%.o64: %.c
+	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O2 $< 
+
+train.mexw64 predict.mexw64:  train.o64 linear.o64 linear_model_matlab.o64 tron.o64
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< linear_model_matlab.o64 linear.o64 tron.o64 -llibmx -llibmex -llibmat -lz -lcholmod -lblas
+
+svmpredict_mex.mexw64 :  svmpredict_mex.o64 svm.o64 svm_model_matlab.o64
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lz -lcholmod
+svmtrain_mex.mexw64 : svmtrain_mex.o64 svm.o64 svm_model_matlab.o64
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lz -lcholmod
+
+%.mexw64: %.o64
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< -llibmx -llibmex -llibmat -lz -lcholmod -lgomp -lpthread
+

=== debian/changelog ===
octave-nan (2.4.4-1) unstable; urgency=low

  [ Sébastien Villemot ]
  * Imported Upstream version 2.4.4
  * Bump Standards-Version to 3.9.2, no changes needed
  * debian/copyright: reflect changes in the upstream package, upgrade to DEP5
  * debian/watch: use qa.debian.org's sf.net redirector
  * debian/patches/fix_makefile: refresh patch
  * debian/rules:
    + use our own clean rule to make the package idempotent
    + do not include MATLAB build script in package
  * Bump to debhelper compatibility level 8
  * Add myself to Uploaders

 -- Thomas Weber <tweber@debian.org>  Thu, 06 Oct 2011 23:12:35 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: math
 Priority: optional
 Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
-Uploaders: Thomas Weber <tweber@debian.org>
+Uploaders: Thomas Weber <tweber@debian.org>,
+           Sébastien Villemot <sebastien.villemot@ens.fr>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 6), cdbs, octave-pkg-dev (>= 0.7.0)
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 8), cdbs, octave-pkg-dev (>= 0.7.0)
+Standards-Version: 3.9.2
 Homepage: http://octave.sourceforge.net/nan/
 Vcs-Git: git://git.debian.org/git/pkg-octave/octave-nan.git
 Vcs-Browser: http://git.debian.org/?p=pkg-octave/octave-nan.git

## octave-nan 2.5.2

=== DESCRIPTION ===
Name: NaN
Version: 2.5.2
Date: 2012-02-10
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for Octave and Matlab for data with and w/o missing values.
Depends: octave (> 3.2.4)
License: GPL version 3 or later
Url: http://pub.ist.ac.at/~schloegl/matlab/NaN

=== debian/changelog ===
octave-nan (2.5.2-1) unstable; urgency=low

  * Imported Upstream version 2.5.2
  * debian/copyright: update to machine-readable format 1.0
  * Bump to debhelper compat level 9
  * Build-depend on octave-pkg-dev >= 1.0.0, to compile against Octave 3.6
  * Bump to Standards-Version 3.9.3, no changes needed
  * debian/patches/fprintf_does_not_like_cells: remove patch, applied upstream

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Mon, 12 Mar 2012 21:02:58 +0000

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Uploaders: Thomas Weber <tweber@debian.org>,
            Sébastien Villemot <sebastien.villemot@ens.fr>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8), cdbs, octave-pkg-dev (>= 0.7.0)
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), cdbs, octave-pkg-dev (>= 1.0.0)
+Standards-Version: 3.9.3
 Homepage: http://octave.sourceforge.net/nan/
 Vcs-Git: git://git.debian.org/git/pkg-octave/octave-nan.git
 Vcs-Browser: http://git.debian.org/?p=pkg-octave/octave-nan.git

=== debian/watch ===
version=3
http://sf.net/octave/nan-([\d.]+)\.tar\.gz

## octave-nan 2.5.5

=== DESCRIPTION ===
Name: NaN
Version: 2.5.5
Date: 2012-04-03
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for Octave and Matlab for data with and w/o missing values.
Depends: octave (> 3.2.0)
License: GPL version 3 or later
Url: http://pub.ist.ac.at/~schloegl/matlab/NaN
Autoload: no

=== src/Makefile ===
--- 
+++ 
@@ -30,11 +30,11 @@
 
 CC  	= gcc
 CXX 	= g++
-CFLAGS 	= -fopenmp -Wall -Wconversion -O2 -fPIC 
+CFLAGS 	= -fopenmp -Wall -Wextra -Wconversion -O2 -fPIC 
 OCTMEX	= mkoctfile$(OCTAVE_VERSION) --mex
 RM      = rm
 
-MEX_OPTION  += -lz -lgomp CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
+MEX_OPTION  += -lgomp CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
 MATMEX      = $(MATLABDIR)/bin/mex $(MEX_OPTION)
 
 PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex 
@@ -52,6 +52,8 @@
 clean:
 	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 
 
+$(PROGS): Makefile
+
 #########################################################
 #	Octave, MATLAB on Linux 
 #########################################################
@@ -59,17 +61,17 @@
 	mkoctfile$(OCTAVE_VERSION) $<
 
 %.mex: %.cpp
-	$(OCTMEX) $<  -lz -lgomp         ## Octave
+	$(OCTMEX) $<  -lgomp         ## Octave
 %.$(MEX_EXT): %.cpp
-	$(MATMEX) $<  -lz -lgomp      ## Matlab
+	$(MATMEX) $<  -lgomp      ## Matlab
 
-svmtrain_mex.mex svmpredict_mex.mex:     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
+svmtrain_mex.mex svmpredict_mex.mex:     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c svmpredict_mex.cpp
 	$(CXX) $(CFLAGS) -c svm.cpp
 	#$(CC)  $(CFLAGS) $(INCOCTAVE) -c svm_model_matlab.c
 	env CC=$(CXX) $(OCTMEX) svmtrain_mex.cpp svm.o svm_model_matlab.c
 	env CC=$(CXX) $(OCTMEX) svmpredict_mex.cpp svm.o svm_model_matlab.c
 
-svmtrain_mex.$(MEX_EXT) svmpredict_mex.$(MEX_EXT):     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c
+svmtrain_mex.$(MEX_EXT) svmpredict_mex.$(MEX_EXT):     svmtrain_mex.cpp svm.h svm.cpp svm_model_matlab.c svmpredict_mex.cpp
 	$(CXX) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm.cpp
 	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c svm_model_matlab.c
 	$(MATMEX) svmtrain_mex.cpp svm.o svm_model_matlab.o
@@ -100,15 +102,15 @@
 	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 $< 
 
 train.mexw32 predict.mexw32:  train.obj linear.obj linear_model_matlab.obj tron.obj
-	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< linear_model_matlab.obj linear.obj tron.obj -llibmx -llibmex -llibmat -lz -lcholmod -lblas
+	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< linear_model_matlab.obj linear.obj tron.obj -llibmx -llibmex -llibmat -lcholmod -lblas
 
 svmpredict_mex.mexw32 :  svmpredict_mex.obj svm.obj svm_model_matlab.obj 
-	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lz -lcholmod
+	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lcholmod
 svmtrain_mex.mexw32 : svmtrain_mex.obj svm.obj svm_model_matlab.obj
-	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lz -lcholmod
+	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lcholmod
 
 %.mexw32: %.obj
-	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex -llibmat -lz -lcholmod -lgomp -lpthread
+	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex -llibmat -lcholmod -lgomp -lpthread
 
 
 
@@ -123,13 +125,13 @@
 	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O2 $< 
 
 train.mexw64 predict.mexw64:  train.o64 linear.o64 linear_model_matlab.o64 tron.o64
-	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< linear_model_matlab.o64 linear.o64 tron.o64 -llibmx -llibmex -llibmat -lz -lcholmod -lblas
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< linear_model_matlab.o64 linear.o64 tron.o64 -llibmx -llibmex -llibmat -lcholmod -lblas
 
 svmpredict_mex.mexw64 :  svmpredict_mex.o64 svm.o64 svm_model_matlab.o64
-	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lz -lcholmod
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lcholmod
 svmtrain_mex.mexw64 : svmtrain_mex.o64 svm.o64 svm_model_matlab.o64
-	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lz -lcholmod
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lcholmod
 
 %.mexw64: %.o64
-	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< -llibmx -llibmex -llibmat -lz -lcholmod -lgomp -lpthread
+	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< -llibmx -llibmex -llibmat -lcholmod -lgomp -lpthread

=== debian/changelog ===
octave-nan (2.5.5-2) unstable; urgency=low

  * hurd.patch: new patch (Closes: #670073)

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Mon, 23 Apr 2012 23:02:12 +0200

octave-nan (2.5.5-1) unstable; urgency=low

  * Imported Upstream version 2.5.5
  * debian/control: mention in long description that package is not autoloaded
  * Describe how to load the package in README.Debian
  * debian/copyright: reflect upstream changes

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Tue, 03 Apr 2012 19:43:39 +0200

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,7 @@
  unbiased estimation significance test, confidence intervals and
  Spearman`s rank correlation included in CORRCOEF.
  .
- Be warned that this package changes the way NaNs are handled in Octave!
+ This package changes the way NaNs are handled in Octave. In order to use
+ its functions, the user must explicitly ask Octave to load the package.
  .
  This Octave add-on package is part of the Octave-Forge project.

## octave-nan 2.5.9

=== DESCRIPTION ===
Name: NaN
Version: 2.5.9
Date: 2014-01-13
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for Octave and Matlab for data with and w/o missing values.
Depends: octave (> 3.2.0)
License: GPLv3+
Url: http://pub.ist.ac.at/~schloegl/matlab/NaN

=== src/Makefile ===
--- 
+++ 
@@ -1,22 +1,25 @@
 ####################################################
-# Copyright 2010, 2011 Alois Schloegl 
+# Copyright 2010, 2011,2012 Alois Schloegl 
 # This is part of the NaN-toolbox - a statistics and machine learning toolbox for data with and without missing values. 
 # http://pub.ist.ac.at/~schloegl/matlab/NaN/
 ####################################################
 
 ### modify directories according to your needs 
 
+# Define non-default octave-version 
 # Octave - global install  (e.g. from debian package)
-# OCTAVE_VERSION = 
+# OCTAVE_VERSION= 
+# Better alternative: define an OCTAVE_VERSION bash variable (or in .bashrc or .profile)
+# OCTAVE_VERSION=-3.6.3
 
 # Matlab configuration
-MATLABDIR = /usr/local/MATLAB/R2010b
+#MATLABDIR = /usr/local/MATLAB/R2010b
 # comment the following line if you use MATLAB on 32-bit operating system
 MEX_OPTION += -largeArrayDims
 
 # Mingw crosscompiler: available at http://www.nongnu.org/mingw-cross-env/
-CROSS   = $(HOME)/src/mingw-cross-env/usr/bin/i686-pc-mingw32-
-CROSS64 = $(HOME)/src/mce-w64/usr/bin/x86_64-w64-mingw32-
+CROSS   = $(HOME)/src/mxe.github.schloegl/usr/bin/i686-pc-mingw32-
+CROSS64 = $(HOME)/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32-
 # include directory for Win32-Matlab include
 W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/
 W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/
@@ -34,17 +37,34 @@
 OCTMEX	= mkoctfile$(OCTAVE_VERSION) --mex
 RM      = rm
 
-MEX_OPTION  += -lgomp CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS)" CXXFLAGS\#"$(CFLAGS)"
+MEX_OPTION  += -lgomp CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS) " CXXFLAGS\#"$(CFLAGS) "
 MATMEX      = $(MATLABDIR)/bin/mex $(MEX_OPTION)
 
 PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex 
 
+### per default only the mex-files for octave are built
 mex4o octave: $(PROGS)
 
-ifneq ( , $(ls -1 $(MATLABDIR) ) )
-MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)
-mex4m matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
+
+### Matlab configuration - search for a matlab directory if not defined above
+ifndef MATLABDIR
+  ifneq ('',$(shell ls -1 /usr/local/MATLAB))
+    # use oldest, typically mex-files a compatible with newer Matlab versions 
+    MATLABDIR=$(shell ls -dt1 /usr/local/MATLAB/R* |tail -1)
+    # alternatively, use latest matlab version
+    #MATLABDIR=$(shell ls -dt1 /usr/local/MATLAB/R* |head -1)
+  endif
 endif
+
+### if the MATLABDIR has been found or defined 
+ifneq ('',MATLABDIR)
+  ifneq ('',$(lshell ls -1 $(MATLABDIR)))
+    MEX_EXT = $(shell $(MATLABDIR)/bin/mexext)
+    mex4m matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
+  endif
+endif
+
+
 mexw32 win32:  $(patsubst %.mex, %.mexw32, $(PROGS))
 mexw64 win64:  $(patsubst %.mex, %.mexw64, $(PROGS))
 all:    octave win32 win64 mex4m
@@ -52,7 +72,7 @@
 clean:
 	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 
 
-$(PROGS): Makefile
+#$(PROGS): Makefile
 
 #########################################################
 #	Octave, MATLAB on Linux

=== debian/changelog ===
octave-nan (2.5.9-1build1) trusty; urgency=medium

  * Rebuild for octave 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Feb 2014 18:26:30 +0000

octave-nan (2.5.9-1) unstable; urgency=medium

  [ Rafael Laboissiere ]
  * Imported Upstream version 2.5.9
  * debian/copyright: Adjust for new upstream release
  * Drop patches hurd.patch and fix_makefile (applied upstream)
  * Remove obsolete DM-Upload-Allowed flag
  * Bump to Standards-Version 3.9.5, no changes needed

  [ Sébastien Villemot ]
  * Use my @debian.org email address

  [ Thomas Weber ]
  * debian/control: Use canonical URLs in Vcs-* fields

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 27 Jan 2014 19:08:39 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,12 @@
 Priority: optional
 Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
 Uploaders: Thomas Weber <tweber@debian.org>,
-           Sébastien Villemot <sebastien.villemot@ens.fr>
-DM-Upload-Allowed: yes
+           Sébastien Villemot <sebastien@debian.org>
 Build-Depends: debhelper (>= 9), cdbs, octave-pkg-dev (>= 1.0.0)
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://octave.sourceforge.net/nan/
-Vcs-Git: git://git.debian.org/git/pkg-octave/octave-nan.git
-Vcs-Browser: http://git.debian.org/?p=pkg-octave/octave-nan.git
+Vcs-Git: git://anonscm.debian.org/pkg-octave/octave-nan.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-octave/octave-nan.git
 
 Package: octave-nan
 Architecture: any

=== debian/watch ===
version=3
http://sf.net/octave/nan-(.+)\.tar\.gz

## octave-nan 2.8.1

=== DESCRIPTION ===
Name: NaN
Version: 2.8.1
Date: 2015-07-06
Author: Alois Schloegl <alois.schloegl@ist.ac.at>
Maintainer: Alois Schloegl
Title: The NaN-toolbox
Description: A statistics and machine learning toolbox for data with and w/o missing values
Depends: octave (> 3.2.0)
License: GPLv3+
Url: http://pub.ist.ac.at/~schloegl/matlab/NaN
Autoload: no
SVNRelease: $Rev: 12813 $

=== src/Makefile ===
####################################################
# Copyright 2010, 2011,2012 Alois Schloegl 
# This is part of the NaN-toolbox - a statistics and machine learning toolbox for data with and without missing values. 
# http://pub.ist.ac.at/~schloegl/matlab/NaN/
####################################################

### modify directories according to your needs 

# Define non-default octave-version 
# Octave - global install  (e.g. from debian package)
# OCTAVE_VERSION= 
# Better alternative: define an OCTAVE_VERSION bash variable (or in .bashrc or .profile)
# OCTAVE_VERSION=-3.6.3

# Matlab configuration
#MATLABDIR = /usr/local/MATLAB/R2010b
# comment the following line if you use MATLAB on 32-bit operating system
MEX_OPTION += -largeArrayDims

# Mingw crosscompiler: available at http://www.nongnu.org/mingw-cross-env/
CROSS   = $(HOME)/src/mxe/usr/bin/i686-w64-mingw32.static-
CROSS64 = $(HOME)/src/mxe/usr/bin/x86_64-w64-mingw32.static-
# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/
W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX   = $(HOME)/bin/win32/gnumex
GNUMEX64 = $(HOME)/bin/win64/gnumex
# building gnumex64 was difficult, these hints were quite useful: 
# http://sourceforge.net/mailarchive/forum.php?thread_name=AANLkTinZvxgC9ezp2P3UCX_a7TAUYuVsp2U40MQUV6qr%40mail.gmail.com&forum_name=gnumex-users
# Instead of building "mex shortpath.c" and "mex uigetpath.c", I used empty m-functions within argout=argin; 
####################################################
MKOCTFILE ?= mkoctfile$(OCTAVE_VERSION)
CC      = gcc
CXX     = g++
CFLAGS 	= -fopenmp -Wall -Wextra -Wconversion -O2
OCTMEX	= $(MKOCTFILE) --mex
RM      = rm

ifneq ($(OS),Windows_NT)
CFLAGS      += -fPIC
endif

ifneq (Darwin,$(shell uname)) 
CFLAGS      += -fopenmp 
MEX_OPTION  += -lgomp 
endif 
 
MEX_OPTION  += CC\#$(CXX) CXX\#$(CXX) CFLAGS\#"$(CFLAGS) " CXXFLAGS\#"$(CFLAGS) "
MATMEX      = $(MATLABDIR)/bin/mex $(MEX_OPTION)

PROGS = histo_mex.mex covm_mex.mex kth_element.mex sumskipnan_mex.mex str2array.mex train.mex svmtrain_mex.mex svmpredict_mex.mex xptopen.mex 

### per default only the mex-files for octave are built
mex4o octave: $(PROGS)


### Matlab configuration - search for a matlab directory if not defined above
ifeq (,$(MATLABDIR))
  ifneq (,$(shell ls -1 /usr/local/ |grep MATLAB))
    # use oldest, typically mex-files are compatible with newer Matlab versions 
    MATLABDIR=/usr/local/MATLAB/$(shell ls -1rt /usr/local/MATLAB/  |grep "^R20*" |head -1)
  endif
endif


### if MATLABDIR has been found or defined 
ifneq (,$(MATLABDIR))
  ifneq (,$(shell ls -1 $(MATLABDIR)/bin/mexext))
    MEX_EXT=$(shell $(MATLABDIR)/bin/mexext)
    mex4m matlab: $(patsubst %.mex, %.$(MEX_EXT), $(PROGS))
  endif
endif


mexw32 win32:  $(patsubst %.mex, %.mexw32, $(PROGS))
mexw64 win64:  $(patsubst %.mex, %.mexw64, $(PROGS))
all:    octave win32 win64 mex4m

clean:
	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 

#$(PROGS): Makefile

#########################################################
#	Octave, MATLAB on Linux 
#########################################################
svm%_mex.mex: svm%_mex.cpp svm.o svm_model_octave.o
	env CC=$(CXX) $(OCTMEX) "$<" svm.o svm_model_octave.o
svm%_mex.$(MEX_EXT): svm%_mex.cpp svm.o svm_model_matlab.o
	$(MATMEX) "$<" svm.o svm_model_matlab.o
%.$(MEX_EXT): %.cpp
	$(MATMEX) "$<"

svm_model_octave.o: svm_model_matlab.c 
	env CC=$(CC) $(MKOCTFILE) -o "$@" -c "$<"
svm_model_matlab.o: svm_model_matlab.c 
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -o "$@" -c "$<"  
svm.o: svm.cpp
	$(CC) $(CFLAGS) -c svm.cpp

train.$(MEX_EXT) predict.$(MEX_EXT): train.c tron.o linear.o linear_model_matlab.c
	$(CC) $(CFLAGS) -I $(MATLABDIR)/extern/include -c linear_model_matlab.c
	$(MATMEX)  -lblas train.c tron.o linear.o linear_model_matlab.o 
	#$(MATMEX) -lblas predict.c tron.o linear.o linear_model_matlab.o
train.mex predict.mex: train.c tron.o linear.o linear_model_matlab.c
	env CC=$(CXX) $(OCTMEX) -lblas train.c tron.o linear.o linear_model_matlab.c
linear.o: linear.cpp
	$(CXX) $(CFLAGS) -c linear.cpp
tron.o: tron.cpp tron.h
	$(CXX) $(CFLAGS) -c tron.cpp

%.oct: %.cc
	mkoctfile$(OCTAVE_VERSION) "$<"

%.mex: %.cpp
	$(OCTMEX) "$<"

#########################################################
#	MATLAB/WIN32
#########################################################
%.obj: %.cpp
	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o "$@" -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 "$<"
%.obj: %.c
	$(CROSS)$(CXX) -fopenmp -c -DMATLAB_MEX_FILE -x c++ -o "$@" -I$(W32MAT_INC) -O2 -DMX_COMPAT_32 "$<" 

train.mexw32 predict.mexw32:  train.obj linear.obj linear_model_matlab.obj tron.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o "$@" -L$(GNUMEX) -s "$<" linear_model_matlab.obj linear.obj tron.obj -llibmx -llibmex -llibmat -lcholmod -lblas

svmpredict_mex.mexw32 :  svmpredict_mex.obj svm.obj svm_model_matlab.obj 
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o "$@" -L$(GNUMEX) -s "$<" svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lcholmod
svmtrain_mex.mexw32 : svmtrain_mex.obj svm.obj svm_model_matlab.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o "$@" -L$(GNUMEX) -s "$<" svm_model_matlab.obj svm.obj -llibmx -llibmex -llibmat -lcholmod

%.mexw32: %.obj
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o "$@" -L$(GNUMEX) -s "$<" -llibmx -llibmex -llibmat -lcholmod -lgomp -lpthread



#########################################################
#	MATLAB/WIN64
#########################################################

## ToDO: fix OpenMP support: currently -fopenmp causes Matlab to crash
%.o64: %.cpp
	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o "$@" -I$(W64MAT_INC) -O2 "$<"
%.o64: %.c
	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o "$@" -I$(W64MAT_INC) -O2 "$<"

train.mexw64 predict.mexw64:  train.o64 linear.o64 linear_model_matlab.o64 tron.o64
	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o "$@" -L$(GNUMEX64) -s "$<" linear_model_matlab.o64 linear.o64 tron.o64 -llibmx -llibmex -llibmat -lcholmod -lblas

svmpredict_mex.mexw64 :  svmpredict_mex.o64 svm.o64 svm_model_matlab.o64
	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o "$@" -L$(GNUMEX64) -s "$<" svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lcholmod
svmtrain_mex.mexw64 : svmtrain_mex.o64 svm.o64 svm_model_matlab.o64
	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o "$@" -L$(GNUMEX64) -s "$<" svm_model_matlab.o64 svm.o64 -llibmx -llibmex -llibmat -lcholmod

%.mexw64: %.o64
	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o "$@" -L$(GNUMEX64) -s "$<" -llibmx -llibmex -llibmat -lcholmod -lgomp -lpthread

=== debian/changelog ===
octave-nan (2.8.1-1ubuntu2) wily; urgency=medium

  * Try harder.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sat, 15 Aug 2015 19:28:32 +0100

octave-nan (2.8.1-1ubuntu1) wily; urgency=medium

  * Call the linker with -fopenmp.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Aug 2015 14:14:26 +0200

octave-nan (2.8.1-1build1) wily; urgency=medium

  * No-change rebuild against liboctave3

 -- Matthias Klose <doko@ubuntu.com>  Sat, 15 Aug 2015 12:00:47 +0000

octave-nan (2.8.1-1) unstable; urgency=medium

  [ Sébastien Villemot ]
  * Imported Upstream version 2.8.1
  * d/copyright: reflect upstream changes.
  * Add Rafael Laboissiere and Mike Miller to Uploaders.

  [ Rafael Laboissiere ]
  * Bump Standards-Version to 3.9.6 (no changes needed)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 20 Jul 2015 10:56:25 +0200

octave-nan (2.5.9-2) unstable; urgency=medium

  * reduce_test_memory_footprint.patch: new patch, reduces memory usage of
    tests. Should fix FTBFS on mips and mipsel. Thanks to Thomas Weber for
    investigating and finding the solution.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 01 Mar 2014 15:55:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Priority: optional
 Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
 Uploaders: Thomas Weber <tweber@debian.org>,
-           Sébastien Villemot <sebastien@debian.org>
+           Rafael Laboissiere <rafael@laboissiere.net>,
+           Sébastien Villemot <sebastien@debian.org>,
+           Mike Miller <mtmiller@debian.org>
 Build-Depends: debhelper (>= 9), cdbs, octave-pkg-dev (>= 1.0.0)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://octave.sourceforge.net/nan/
 Vcs-Git: git://anonscm.debian.org/pkg-octave/octave-nan.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-octave/octave-nan.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/cdbs/1/class/octave-pkg.mk

# Do not use the clean target provided by the package: it will delete the
# binary MATLAB MEX files, which we cannot regenerate, hence making the package
# build not idempotent. Instead, use our own clean rule.
DEB_MAKE_CLEAN_TARGET = dummy

# Also clean test file and MATLAB build script (this script is automatically
# copied from src/ to inst/ by Octave packaging system)
clean::
	rm -f src/*.o src/*.mex
	rm -f test/debug.mat inst/make.m

# Don't include MATLAB build script in the package
clean-files::
	find debian/ -name make.m | xargs rm

## octave-nan 3.0.3

=== debian/changelog ===
octave-nan (3.0.3-1) unstable; urgency=medium

  * Imported Upstream version 3.0.3
  * d/p/build-against-libsvm-dev.patch: Adjust for new API of libsvm

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 14 Aug 2016 11:55:47 -0300

octave-nan (3.0.2-2) unstable; urgency=medium

  * Build against libsvm-dev (Closes: 833940)
    + d/control: Build-depends on libsvm-dev
    + d/p/build-against-libsvm-dev.patch: New patch

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 13 Aug 2016 08:52:45 -0300

octave-nan (3.0.2-1) unstable; urgency=medium

  * Imported Upstream version 3.0.2
  * Bump Standards-Version to 3.9.8 (no changes needed)

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 04 Aug 2016 11:52:07 -0300

octave-nan (3.0.1-1) unstable; urgency=medium

  * Imported Upstream version 3.0.1

 -- Rafael Laboissiere <rafael@laboissiere.net>  Thu, 17 Mar 2016 13:37:05 +0100

octave-nan (3.0-1) unstable; urgency=medium

  [ Sébastien Villemot ]
  * Imported Upstream version 3.0

  [ Rafael Laboissiere ]
  * d/control: Use secure URIs in the Vcs-* fields
  * d/control: Bump Standards-Version to 3.9.7 (no changes needed)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 19 Feb 2016 22:23:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Priority: optional
 Maintainer: Debian Octave Group <pkg-octave-devel@lists.alioth.debian.org>
 Uploaders: Thomas Weber <tweber@debian.org>,
-           Rafael Laboissiere <rafael@laboissiere.net>,
+           Rafael Laboissiere <rafael@debian.org>,
            Sébastien Villemot <sebastien@debian.org>,
            Mike Miller <mtmiller@debian.org>
-Build-Depends: debhelper (>= 9), cdbs, octave-pkg-dev (>= 1.0.0)
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9), cdbs, octave-pkg-dev (>= 1.0.0),
+ libsvm-dev
+Standards-Version: 3.9.8
 Homepage: http://octave.sourceforge.net/nan/
-Vcs-Git: git://anonscm.debian.org/pkg-octave/octave-nan.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-octave/octave-nan.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-octave/octave-nan.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-octave/octave-nan.git
 
 Package: octave-nan
 Architecture: any
